
!CompiledMethod methodsFor: '*FuelCompatibilityBeforePharo20' stamp: 'MartinDias 5/21/2012 12:21'!
abstractBytecodeMessageAt: pc
	"Answer the abstract bytecode message at pc in the receiver."
	^[(InstructionStream new method: self pc: pc) interpretNextInstructionFor: nil]
		on: MessageNotUnderstood
		do: [:ex| ex message]! !

!CompiledMethod methodsFor: '*FuelCompatibilityBeforePharo20' stamp: 'MartinDias 5/21/2012 11:58'!
abstractBytecodeMessagesDo: aBlock
	"Evaluate aBlock with the sequence of abstract bytecodes in the receiver"
	self abstractBytecodeMessagesFrom: self initialPC
		to: self endPC
		do: aBlock! !

!CompiledMethod methodsFor: '*FuelCompatibilityBeforePharo20' stamp: 'MartinDias 5/21/2012 11:58'!
abstractBytecodeMessagesFrom: startpc to: endpc do: aBlock
	"Evaluate aBlock with the sequence of abstract bytecodes from startpc through endpc in the receiver"
	| scanner |
	scanner := InstructionStream new method: self pc: startpc.
	[scanner pc <= endpc] whileTrue:
		[[scanner interpretNextInstructionFor: nil]
			on: MessageNotUnderstood
			do: [:ex| aBlock value: ex message]]! !

!CompiledMethod methodsFor: '*FuelCompatibilityBeforePharo20' stamp: 'MartinDias 5/18/2012 00:32'!
isDoIt
	^self selector isDoIt.! !

!CompiledMethod methodsFor: '*FuelCompatibilityBeforePharo20' stamp: 'MartinDias 10/22/2010 12:56'!
isNamedPrimitive 

	^ self primitive = 117! !

!Date class methodsFor: '*FuelCompatibilityBeforePharo20' stamp: 'MaxLeske 10/17/2012 20:58'!
materializeFrom: aDecoder
	^ self 
		starting: (DateAndTime materializeFrom: aDecoder)
		duration: (Duration days: 1)! !

!Date methodsFor: '*FuelCompatibilityBeforePharo20' stamp: 'MaxLeske 10/17/2012 20:58'!
serializeOn: anEncoder
	start serializeOn: anEncoder! !

!ClassFactoryForTestCase methodsFor: '*FuelCompatibilityBeforePharo20' stamp: 'MarianoMartinezPeck 4/19/2012 19:29'!
silentlyNewClassInCategory: category
	^self silentlyNewSubclassOf: self defaultSuperclass instanceVariableNames: '' classVariableNames: '' category: category! !

!ClassFactoryForTestCase methodsFor: '*FuelCompatibilityBeforePharo20' stamp: 'MarianoMartinezPeck 4/19/2012 19:16'!
silentlyNewSubclassOf: aClass instanceVariableNames: ivNamesString classVariableNames:  classVarsString
	^ self silentlyNewSubclassOf: aClass instanceVariableNames: ivNamesString classVariableNames:  classVarsString category: self defaultCategoryPostfix
! !

!ClassFactoryForTestCase methodsFor: '*FuelCompatibilityBeforePharo20' stamp: 'MarianoMartinezPeck 8/7/2012 19:12'!
silentlyNewSubclassOf: aClass instanceVariableNames: ivNamesString classVariableNames:  classVarsString category: category

	| default newClass |
	[ newClass := aClass 
			subclass: self newName 
			instanceVariableNames: ivNamesString 
			classVariableNames: classVarsString 
			poolDictionaries: '' 
			category: (self packageName, '-', category) asSymbol.
	] fuelValueWithoutNotifications.

	self createdClasses add: newClass.
	^newClass
	! !

!ClassFactoryForTestCase methodsFor: '*FuelCompatibilityBeforePharo20' stamp: 'MarianoMartinezPeck 8/7/2012 19:12'!
silentlyNewSubclassOf: aClass instanceVariableNames: ivNamesString classVariableNames:  classVarsString package: packageName

	| default newClass |
	[ newClass := aClass 
			subclass: self newName 
			instanceVariableNames: ivNamesString 
			classVariableNames: classVarsString 
			poolDictionaries: '' 
			category: packageName asSymbol.
	] fuelValueWithoutNotifications.

	self createdClasses add: newClass.
	^newClass
	! !

!ClassFactoryForTestCase methodsFor: '*FuelCompatibilityBeforePharo20' stamp: 'MarianoMartinezPeck 4/19/2012 19:06'!
withNotificationsNewClass
	^  self withNotificationsNewClassWithInstanceVariableNames: ''! !

!ClassFactoryForTestCase methodsFor: '*FuelCompatibilityBeforePharo20' stamp: 'MarianoMartinezPeck 4/19/2012 19:23'!
withNotificationsNewClassWithInstanceVariableNames: instanceVariableNames
	^ self newSubclassOf: Object instanceVariableNames: instanceVariableNames classVariableNames:  '' category: self defaultCategoryPostfix
	! !

!OrderedCollection methodsFor: '*FuelCompatibilityBeforePharo20' stamp: 'mariano 7/31/2012 17:10'!
removeDuplicates
	| iterator |
	"Remove the copies of elements, but keep the same order"
	
	self ifEmpty: [ ^ self ].
	iterator := 1.
	[ iterator <= self size ]
		whileTrue: [ | each newIndex |
			each := self at: iterator.			
			[ newIndex := (self indexOf: each startingAt: iterator+1).
			newIndex > 0 ]
				whileTrue: [ self removeAt: newIndex ].
			iterator := iterator + 1.
	 ]! !

!DateAndTime methodsFor: '*FuelCompatibilityBeforePharo20' stamp: 'MarianoMartinezPeck 7/23/2012 12:31'!
fuelSet: julianDayNumber nanoSecond: nanoSeconds seconds: numberOfSeconds offset: anOffset
	jdn := julianDayNumber.
	nanos := nanoSeconds.
	seconds := numberOfSeconds.
	offset := anOffset.! !

!BlockClosure methodsFor: '*FuelCompatibilityBeforePharo20' stamp: 'MartinDias 5/21/2012 11:57'!
abstractBytecodeMessagesDo: aBlock
	"Evaluate aBlock with the sequence of abstract bytecodes in the receiver."
	self method
		abstractBytecodeMessagesFrom: startpc
		to: self endPC
		do: aBlock

	"| msgs |
	 msgs := OrderedCollection new.
	 (SortedCollection sortBlock: [:a :b| a compare: b caseSensitive: false]) sortBlock
		abstractBytecodeMessagesDo: [:msg| msgs add: msg selector].
	 msgs"! !

!BlockClosure methodsFor: '*FuelCompatibilityBeforePharo20' stamp: 'MartinDias 5/21/2012 12:20'!
blockCreationBytecodeMessage
	"Answer the abstract bytecode message that created the receiver."
	| blockCreationBytecodeSize |
	^self method abstractBytecodeMessageAt: startpc - (blockCreationBytecodeSize := 4)

	"(SortedCollection sortBlock: [:a :b| a compare: b caseSensitive: false]) sortBlock blockCreationBytecodeMessage"! !

!BlockClosure methodsFor: '*FuelCompatibilityBeforePharo20' stamp: 'MartinDias 5/21/2012 12:19'!
endPC
	^self blockCreationBytecodeMessage arguments last + startpc - 1! !

!BlockClosure methodsFor: '*FuelCompatibilityBeforePharo20' stamp: 'MarianoMartinezPeck 8/7/2012 19:20'!
fuelValueWithoutNotifications

	SystemChangeNotifier uniqueInstance doSilently: [ self value ]
! !

!BlockClosure methodsFor: '*FuelCompatibilityBeforePharo20' stamp: 'MartinDias 5/21/2012 11:56'!
isClean
	"Answer if the receiver does not close-over any variables other than globals, and does
	 not ^-return (does not close over the home context).  Clean blocks are amenable to
	 being created at compile-time."
	self numCopiedValues > 0 ifTrue:
		[^false].
	self abstractBytecodeMessagesDo:
		[:msg|
		(#(	pushReceiver
			pushReceiverVariable: popIntoReceiverVariable: storeIntoReceiverVariable:
			methodReturnConstant: methodReturnReceiver methodReturnTop)
				includes: msg selector) ifTrue:
					[^false]].
	^true

	"clean:"
		"[] isClean"
		"[:a :b| a < b] isClean"
	"unclean"
		"[^nil] isClean"
		"[self class] isClean"
		"| v | v := 0.
		 [v class] isClean"! !

!FLBasicSerializationTest methodsFor: '*FuelCompatibilityBeforePharo20' stamp: 'MaxLeske 10/18/2012 07:44'!
testDateOffsets
	| bst sast materialized object |
	bst := TimeZone timeZones third.
	sast := TimeZone timeZones fourth.
	
	DateAndTime localTimeZone: bst.
	self assert: DateAndTime now offset equals: 1 hour.
	object := Date fromDays: 37023.
	self assert: object start offset equals: 1 hour.
	materialized := self resultOfSerializeAndMaterialize: object.
	self assert: materialized start offset equals: 1 hour.
	
	DateAndTime localTimeZone: sast.
	self assert: DateAndTime now offset equals: 2 hours.
	object := Date fromDays: 37023.
	self assert: object start offset equals: 2 hours.
	materialized := self resultOfSerializeAndMaterialize: object.
	self assert: materialized start offset equals: 2 hours.
	! !

!FLBasicSerializationTest methodsFor: '*FuelCompatibilityBeforePharo20' stamp: 'MaxLeske 10/18/2012 07:50'!
testDateOffsetsChanging
	| bst sast object |
	bst := TimeZone timeZones third.
	sast := TimeZone timeZones fourth.
	
	DateAndTime localTimeZone: bst.
	self assert: DateAndTime now offset equals: 1 hour.
	object := Date fromDays: 37023.
	self assert: object start offset equals: 1 hour.
	self serialize:object.
	
	DateAndTime localTimeZone: sast.
	self assert: DateAndTime now offset equals: 2 hours.
	object := Date fromDays: 37023.
	self assert: object start offset equals: 2 hours.
	"serialization sould be independent of timezone change"
	self assert: self materialized start offset equals: 1 hour
	! !
